.TH XWMENUMGR 3X
.SH NAME
XwmenumgrWidgetClass \- the X Widgets menu manager meta
widget.
.SH SYNOPSIS
#include <X11/Intrinsic.h>
.br
#include <X11/StringDefs.h>
.br
#include <Xw/Xw.h>
.SH CLASSES
The menu manager class is built the Core, Composite,
Constraint and XwManager classes.
.SH DESCRIPTION
The MenuMgr class is an X Widget meta class.  It is never
instantiated as a widget.  Its sole purpose is as a
supporting superclass for other menu manager widget classes.
.SH "NEW RESOURCES"
The menu manager defines a set of resource types which may
be used by the programmer to specify the data for widgets
which are a subclass of MenuMgr.  To specify any of these
resources within the .Xdefaults file, simply drop the XtN
prefix from the resource name.  The following table contains
the set of resources defined by MenuMgr.
.IP "" 19
MenuMgr Resource Set
.ti -24
Name                   Class                  Type      Default
.br
.ti -24
_____________________________________________________________________
.br
.ti -24
XtNassociateChildren   XtCAssociateChildren   Boolean   TRUE
.br
.ti -24
XtNmenuPost            XtCMenuPost            String    "<Btn1Down>"
.br
.ti -24
XtNmenuSelect          XtCMenuSelect          String    "<Btn1Up>"
.br
.ti -24
XtNmenuUnpost          XtCMenuUnpost          String    NULL
.br
.ti -24
XtNkbdSelect           XtCKBDSelect           String    "<Key>Select"
.br
.TP 5
XtNassociateChildren
.br
This resource indicates whether the menu hierarchy
controlled by the menu manager is accessible only from
within the associated widget, or from within the widget
and any of the widget's children.
.TP 5
XtNmenuPost
.br
This string resource describes the button event and any
required modifiers needed to post one of the top level
menupanes controlled by the menu manager.  The string
is specified using the syntax supported by the Xt
Intrinsic's translation manager, with three exceptions.
.IP "" 5
First, only a single event may be specified.  Secondly,
the event must be a ButtonPress or ButtonRelease event.
Thirdly, all modifiers specified are interpreted as
being exclusive; this means that only the specified
modifiers can be present when the button event occurs.
.TP 5
XtNmenuSelect
.br
This string resource describes the button event and any
required modifiers needed to select a menu button
within any of the menupanes controlled by the menu
manager.  The string is specified using the syntax
supported by the Xt Intrinsic's translation manager,
with three exceptions. First, only a single event may
be specified.  Secondly, the event must be a
ButtonPress or ButtonRelease event.  Thirdly, all
modifiers specified are interpreted as being exclusive;
this means that only the specified modifiers can be
present when the button event occurs.
.TP 5
XtNmenuUnpost
.br
This string resource describes the key event and any
required modifiers needed to unpost the currently
viewable set of menupanes controlled by the menu
manager.  This provides the user with the means for
unposting a menu hierarchy from the keyboard, without
selecting a menu button.  The string is specified using
the syntax supported by the Xt Intrinsic's translation
manager, with three exceptions. First, only a single
event may be specified.  Secondly, the event must be a
key event. Thirdly, all modifiers specified are
interpreted as being exclusive; this means that only
the specified modifiers can be present when the button
event occurs.
.TP 5
XtNkbdSelect
.br
This string resource describes the key event and any
required modifiers needed to select the currently
highlighted menu button. This provides the user with
the means for selecting a menu item from the keyboard,
without being required to use the mouse.  The string is
specified using the syntax supported by the Xt
Intrinsic's translation manager, with three exceptions.
First, only a single event may be specified.  Secondly,
the event must be a key event. Thirdly, all modifiers
specified are interpreted as being exclusive; this
means that only the specified modifiers can be present
when the button event occurs.
.SH ORIGIN
Hewlett-Packard Company.
.SH "SEE ALSO"
CORE(3X), XWMANAGER(3X),
.br
Programming With The HP X Widgets,
.br
Programming With Xt Intrinsics,
.br
Programming With Xlib.
