.TH XWMENUSEP 3X
.SH NAME
XwmenuSepWidgetClass \- the X Widget's menu item separator
widget.
.SH SYNOPSIS
#include <X11/StringDefs.h>
.br
#include <X11/Intrinsic.h>
.br
#include <Xw/Xw.h>
.br
#include <Xw/MenuSep.h>
.SH CLASSES
MenuSep is built from the Core, XwPrimitive, XwButton, and
XwMenuBtn classes.
.PP
The widget class to use when creating a menu separator
widget is XwmenuSepWidgetClass.
.PP
The class name for this widget is MenuSep.
.SH DESCRIPTION
The MenuSep widget is a primitive widget to be used as an
item separator placed between items in a menu.  Several
different line drawing styles are provided.
.SH "NEW RESOURCES"
The MenuSep widget defines a one additional resource type.
The programmer can also set the values for the Core and
Primitive resources to set attributes for this widget.  The
Button and MenuButton resources are unused for this widget.
.IP "" 17
MenuSep Resource Set
.ti -19
Name               Class              Type   Default
.br
.ti -19
__________________________________________________________
.br
.ti -19
XtNseparatorType   XtCseparatorType   int    XwSINGLE_LINE
.br
.TP 5
XtNseparatorType
.br
This resource defines the type of line drawing to be
done in the menu separator widget.  Five different line
drawing styles are provided.  They are single, double,
single dashed, double dashed and no line.  The
separator type can be set through an argument list by
using one of the defines: XwSINGLE_LINE, XwDOUBLE_LINE,
XwSINGLE_DASHED_LINE, XwDOUBLE_DASHED_LINE, and
XwNO_LINE.  The separator type can be set through the
\&.Xdefaults file by using one of the following strings:
single_line, double_line single_dashed_line,
double_dashed_line and no_line.
.PP
The line drawing done within the menu separator will be
automatically centered within the height of the widget.
.PP
The separator type of no_line is provided as an escape to
the application programmer who needs a different style of
drawing.  To create an alternate style, a pixmap the height
of the widget can be created.  After the separator widget
has been created, this pixmap can be used as the background
pixmap by building an argument list using the
XtNbackgroundPixmap argument type as defined by Core and
setting the widgets background through XtSetValues.
.br
Whenever the widget is redrawn its background will be
displayed which contains the desired separator drawing.
.br
Note that the pixmap can only be set after the widget is
created.  If set when created, it will be overridden by the
normal background pixmap created by the Primitive class.
.SH "INHERITED RESOURCES"
The following resources are inherited from the named
superclasses:
.IP "" 17
Core Resource Set \-\- CORE(3X)
.ti -22
Name                   Class                  Type             Default
.br
.ti -22
__________________________________________________________________________
.br
.ti -22
XtNancestorSensitive   XtCSenstitive          Boolean          TRUE
.br
.ti -22
XtNx                   XtCPosition            int              0
.br
.ti -22
XtNy                   XtCPosition            int              0
.br
.ti -22
XtNwidth               XtCWidth               int              0
.br
.ti -22
XtNheight              XtCHeight              int              0
.br
.ti -22
XtNdepth               XtCDepth               int              0
.br
.ti -22
XtNbackground          XtCBackground          Pixel            White
.br
.ti -22
XtNbackgroundPixmap    XtCPixmap              Pixmap           Unspecified
.br
.ti -22
XtNborderWidth         XtCBorderWidth         int              1
.br
.ti -22
XtNborderColor         XtCBorderColor         Pixel            Black
.br
.ti -22
XtNborderPixmap        XtCPixmap              Pixmap           Unspecified
.br
.ti -22
XtNsensitive           XtCSensitive           Boolean          TRUE
.br
.ti -22
XtNmappedWhenManaged   XtCMappedWhenManaged   Boolean          TRUE
.br
.ti -22
XtNdestroyCallback     XtCCallback            Pointer          NULL
.br
.ti -22
XtNtranslations        XtCTranslations        XtTranslations   NULL
.br
.IP "" 10
Primitive Resource Set \-\- XWPRIMITIVE(3X)
.ti -15
Name                    Class                   Type      Default
.br
.ti -15
________________________________________________________________________
.br
.ti -15
XtNforeground           XtCForeground           Pixel     Black
.br
.ti -15
XtNbackgroundTile       XtCBackgroundTile       int       background
.br
.ti -15
XtNtraversalType        XtCTraversalType        int       highlight_off
.br
.ti -15
XtNhighlightStyle       XtCHighlightStyle       int       pattern_border
.br
.ti -15
XtNhighlightColor       XtCForeground           Pixel     Black
.br
.ti -15
XtNhighlightTile        XtCHighlightTile        int       50_foreground
.br
.ti -15
XtNhighlightThickness   XtCHighlightThickness   int       0
.br
.ti -15
XtNrecomputeSize        XtCRecomputeSize        Boolean   TRUE
.br
.ti -15
XtNselect               XtCCallback             Pointer   NULL
.br
.ti -15
XtNrelease              XtCCallback             Pointer   NULL
.br
.SH TRANSLATIONS
The menu separator widget defines no translations.
.SH ACTIONS
The menu separator widget defines no actions.
.SH ORIGIN
Hewlett-Packard Company.
.SH "SEE ALSO"
CORE(3X), XWPRIMITIVE(3X),
.br
Programming With The HP X Widgets,
.br
Programming With Xt Intrinsics,
.br
Programming With Xlib.
